

//const int definiert hier dauerhaft die Pins an denen die Sensoren angeschlossen sind
const int schalter = 2;     // Pin an dem der Kugelhalter angeschlossen wird
const int lichtschranke = 3;     // Pin an dem die Lichtschranke angeschlossen ist
const int ledPin =  13;      // LED zum anzeigen ob das System bereit ist

//Hier werden die Variablen definiert die sich während des Durchlaufs ändern
int schalterState = 0;         // Liest den Zustand des Kugelhalters aus und schreibt ihn in eine Variable
int lichtschrankenState = 0;         // Liest den Zustand der Lichtschranke aus und schreibt ihn in eine Variable

//Hier werden die Variablen definiert die sich während des Versuchs ändern (unsigned long, da große Werte erhalten werden)
unsigned long startTime ;                    // Speichert den Wert in ms wann der Haltemagnet gelöst wurde 
unsigned long sensor01Time ;                 // Speichert den Wert in ms wann die Lichtschranke 01 ausgelöst wurde


//Hier wird der letzte Status der Sensoren eingetragen um eine Zustandsänderung messen zu können
int lastschalterState = 0;               // Speichert den letzten Zustand des Schalters und schreibt ihn in eine Variable
int lastlichtschrankenState = 0;         // Speichert den letzten Zustand der Lichtschranke und schreibt ihn in eine Variable




void setup() {  
  Serial.begin(9600);                   //Startet die Serielle Kommunikation
  pinMode(ledPin, OUTPUT);              // Setzt die Status LED als Ausgang

  pinMode(schalter, INPUT);             // Setzt den Pin des Kugelhalters als Eingang
  pinMode(lichtschranke, INPUT);        // Setzt den Pin der Lichtschranke als Eingang
  
  Serial.println("Bereit");             // Schreibt den Text "Bereit" um zu signalisieren, dass der Arduino Hochgefahren ist
  digitalWrite(ledPin, HIGH);           // Schaltet die LED an um zu signalisieren, dass der Arduino Hochgefahren ist
}


void loop() {

  
  // Beobachte den Status von Lichtschranke und Schalter
  
  schalterState = digitalRead(schalter);
  lichtschrankenState = digitalRead(lichtschranke);

  // Wenn sich der Schalter Geöffnet hat und vorher geschlossen war schreibt er die Zeit in "starttime" 
  
  if (schalterState == LOW && lastschalterState== HIGH) {
   startTime = millis(); 
    lastschalterState = schalterState;   //Ändert den letzten Zustand des Schalters um die Schleife zu verlassen.
     Serial.println("Start");
  } 
  
else if (lichtschrankenState == LOW && lastlichtschrankenState == HIGH){ 
  sensor01Time   = millis()- startTime;   
    Serial.print("Gemessene Zeit:   ");
    Serial.print(sensor01Time);
    Serial.println("ms");
 lastlichtschrankenState = lichtschrankenState;    //Ändert den letzten Zustand des Schalters um die Schleife zu verlassen.

    
}
else{
    lastschalterState = schalterState;                //Ändert den letzten Zustand des Schalters 
    lastlichtschrankenState = lichtschrankenState;    //Ändert den letzten Zustand des Schalters 


    
   }


  
}
